#!/bin/sh
set -e
#Ubuntu #3 plugin for multicd.sh
#version 5.0.3
#Copyright (c) 2009 maybeway36
#
#Permission is hereby granted, free of charge, to any person obtaining a copy
#of this software and associated documentation files (the "Software"), to deal
#in the Software without restriction, including without limitation the rights
#to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#copies of the Software, and to permit persons to whom the Software is
#furnished to do so, subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in
#all copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#THE SOFTWARE.
if [ $1 = scan ];then
	if [ -f ubuntu3.iso ];then
		echo "Ubuntu #3 (for using mutiple versions on one disc)*"
		echo "  *Note: this plugin only works with Ubuntu 9.10 or newer (or distros based on Ubuntu 9.10 or newer)."
		echo > tags/ubuntu3
	fi
elif [ $1 = copy ];then
	if [ -f ubuntu3.iso ];then
		echo "Copying Ubuntu #3..."
		if [ ! -d ubuntu3 ];then
			mkdir ubuntu3
		fi
		if grep -q "`pwd`/ubuntu3" /etc/mtab ; then
			umount ubuntu3
		fi
		mount -o loop ubuntu3.iso ubuntu3/
		cp -R ubuntu3/casper multicd-working/ubuntu3 #Live system
		cp -R ubuntu3/.disk multicd-working/.disk-ubuntu3 #.disk
		umount ubuntu3;rmdir ubuntu3
		if false;then
		echo -n "Making initrd..."
		if [ -f multicd-working/ubuntu3/initrd.lz ];then
			cp multicd-working/ubuntu3/initrd.lz tmpinit.lzma
			lzma -d tmpinit.lzma
		else
			gzip -cd multicd-working/ubuntu3/initrd.gz>tmpinit
		fi
		mkdir ubuntu3-inittmp
		cd ubuntu3-inittmp
		cpio -id < ../tmpinit
		rm ../tmpinit
		perl -pi -e 's/LIVE_MEDIA_PATH=casper/LIVE_MEDIA_PATH=ubuntu3/g' scripts/casper
		find . | cpio --create --format='newc' | gzip -c > ../multicd-working/ubuntu3/initrd.gz
		rm ../multicd-working/ubuntu3/initrd.lz||true
		cd ..
		rm -r ubuntu3-inittmp
		echo " done."
		fi
	fi
elif [ $1 = writecfg ];then
if [ -f ubuntu3.iso ];then
if [ -f multicd-working/ubuntu3/initrd.lz ];then
cat >> multicd-working/boot/isolinux/isolinux.cfg << "EOF"
label ubuntu3-live
  menu label ^Try Ubuntu #3 without any change to your computer
  kernel /ubuntu3/vmlinuz
  append  file=/cdrom/preseed/ubuntu.seed initrd=/ubuntu3/initrd.lz quiet splash -- live-media-path=/ubuntu3
label ubuntu3-live-install
  menu label ^Install Ubuntu #3
  kernel /ubuntu3/vmlinuz
  append  file=/cdrom/preseed/ubuntu.seed only-ubiquity initrd=/ubuntu3/initrd.lz quiet splash -- live-media-path=/ubuntu3
EOF
else
cat >> multicd-working/boot/isolinux/isolinux.cfg << "EOF"
label ubuntu3-live
  menu label ^Try Ubuntu #3 without any change to your computer
  kernel /ubuntu3/vmlinuz
  append  file=/cdrom/preseed/ubuntu.seed initrd=/ubuntu3/initrd.gz quiet splash -- live-media-path=/ubuntu3
label ubuntu3-live-install
  menu label ^Install Ubuntu #3
  kernel /ubuntu3/vmlinuz
  append  file=/cdrom/preseed/ubuntu.seed only-ubiquity initrd=/ubuntu3/initrd.gz quiet splash -- live-media-path=/ubuntu3
EOF
fi
if [ -f tags/ubuntu3.name ];then
	perl -pi -e "s/Ubuntu\ \#3/$(cat tags/ubuntu3.name)/g" multicd-working/boot/isolinux/isolinux.cfg
fi
fi
else
	echo "Usage: $0 {scan|copy|writecfg}"
	echo "Use only from within multicd.sh or a compatible script!"
	echo "Don't use this plugin script on its own!"
fi
